--[[
	TODO:
		* Echo out the name of the quest when you check it (would require some way of getting a quest's name from its ID)
	CHANGELOG:
		1.0 : Initial release.
		1.1 : Added quest link support
]]

function QQ_OnLoad(self)
	local f = CreateFrame("Frame","QueryQuestFrame",UIParent)
	self:RegisterEvent("QUEST_QUERY_COMPLETE")
	self:RegisterEvent("COMMENTATOR_ENTER_WORLD")
	SLASH_QUERYQUEST1, SLASH_QUERYQUEST2 = '/qq', '/queryquest'
	
	qqVersion = "1.1"
end

function QQ_OnEvent(self, event, ...)
	if (event == "QUEST_QUERY_COMPLETE") then
		qqQueried = 1
		QQ_Check()
	end
	
	if (event == "COMMENTATOR_ENTER_WORLD") then
		qqQueried = 0
		qqQuest = 0
	end
end

function QQ_Msg(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cffd2b48c[QueryQuest]|r "..msg)
end

local function QQ_Slash(cmd)
	if (strmatch(cmd,"^%d+$")) then -- Just a number
		qqQuest = cmd
		if (qqQueried == 1) then QQ_Check() else QueryQuestsCompleted() end
		
	elseif (strmatch(cmd,"|Hquest")) then -- Quest link
		qqQuest = strmatch(cmd,"|Hquest:(%d+):")
		if (qqQueried == 1) then QQ_Check() else QueryQuestsCompleted() end
		
	elseif ((cmd == "v") or (cmd == "version")) then -- version request
		QQ_Msg("QueryQuest version "..qqVersion)
		
	else -- nothing or maybe help
		QQ_Msg("QueryQuest commands:")
		QQ_Msg("/qq xxxxx - See if you've completed the quest with ID xxxxx")
		QQ_Msg("/qq [Quest Link] - See if you've completed the given quest")
		QQ_Msg("/qq v[ersion] - Show addon version")
		QQ_Msg("/qq help - Show this help")
		QQ_Msg("To get a quest's ID, look it up on wowhead.com and copy the number at the end of the URL")
	end
end
SlashCmdList["QUERYQUEST"] = QQ_Slash

function QQ_Check()
	if (GetQuestsCompleted()[qqQuest+0]) then
		QQ_Msg("|cff00ff00That quest has been completed.|r")
	else
		QQ_Msg("|cffff0000That quest has NOT been completed.|r")
	end
end